  
;############ Getting Dimensions and # of Bands of an image-file    ############
(define get_width_c
    (get-ffi-obj 'get_width_c dylib-path
                (_fun [filename : _string]
                      -> [width : _int])))
(define get_height_c
    (get-ffi-obj 'get_height_c dylib-path
                (_fun [filename : _string]
                      -> [height : _int])))
(define get_numBands_c
    (get-ffi-obj 'get_numBands_c dylib-path
                (_fun [filename : _string]
                      -> [height : _int])))

;###############################################################################
;###################             Loading images             ####################
(define vigra_importimage_c
  (get-ffi-obj 'vigra_importimage_c dylib-path
               (_fun (img_vector width height filename) :: [img_vector : _cvector]
                     [width : _int]
                     [height : _int]
                     [filename : _string]
                     -> (res :  _int))))


(define (loadimage filename)
  (let* ((width (get_width_c filename))
         (height (get_height_c filename))
	 (img (make-image width height 0.0))
         (foo  (vigra_importimage_c (image-data img) width height filename)))
   (case foo
      ((0) img)
      ((1) (error "Error in vigraplt.impex.loadimage: Image cannot be loaded by vigra!"))
      ((2) (error "Error in vigraplt.impex.loadimage: Image is not grayscale!"))
      ((3) (error "Error in vigraplt.impex.loadimage: Sizes do not match!")))))


;###############################################################################
;###################             Saving images              ####################
(define vigra_exportimage_c
  (get-ffi-obj 'vigra_exportimage_c dylib-path
               (_fun (img_vector width height filename) :: [img_vector : _cvector]
                     [width : _int]
                     [height : _int]
                     [filename : _string]
                     -> (res :  _int))))

(define (saveimage  image filename)
  (let* ((foo  (vigra_exportimage_c (image-data image) (image-width image) (image-height image) filename)))
   (case foo
      ((0) #t)
      ((1) (error "Error in vigraplt.impex.saveimage: Image cannot be saved by vigra!")))))
