;###############################################################################
;###################         Erode image                   ####################

(define vigra_discerosion_c
  (get-ffi-obj 'vigra_discerosion_c dylib-path
               (_fun (img_vector1 img_vector2  width height radius) :: [img_vector1 : _cvector]
                     [img_vector2 : _cvector]
                     [width : _int]
                     [height : _int]
                     [radius : _int]
                     -> (res :  _int))))

(define (erodeimage image radius)
  (let* ((width  (image-width  image))
	 (height (image-height image))
	 (img2 (make-image width height 0.0))
	 (foo   (vigra_discerosion_c (image-data image) (image-data img2) width height radius)))
    (case foo
      ((0) img2)
      ((1) (error "Error in vigraplt.morphology:erodeimage: Erosion of image failed!!")))))

;###############################################################################
;###################         Dilate image                   ####################

(define vigra_discdilation_c
  (get-ffi-obj 'vigra_discdilation_c dylib-path
               (_fun (img_vector1 img_vector2  width height radius) :: [img_vector1 : _cvector]
                     [img_vector2 : _cvector]
                     [width : _int]
                     [height : _int]
                     [radius : _int]
                     -> (res :  _int))))

(define (dilateimage image radius)
  (let* ((width  (image-width  image))
	 (height (image-height image))
	 (img2 (make-image width height 0.0))
	 (foo   (vigra_discdilation_c (image-data image) (image-data img2) width height radius)))
    (case foo
      ((0) img2)
      ((1) (error "Error in vigraplt.morphology:dilateimage: Erosion of image failed!!")))))

;###############################################################################
;###################         Opening  image                 ####################

(define (openingimage image radius)
  (dilateimage (erodeimage image radius) radius))


;###############################################################################
;###################         Closing image                  ####################

(define (closingimage image radius)
  (erodeimage (dilateimage image radius) radius))